//
//  MAPersistentDocument.h
//  MAStore
//
//  Created by Stefan Fuerst on 22.04.18.
//  Copyright (c) 2018 Media Atelier. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "StorageKitSavePanel.h"


@class StorageKitBusyWindowController;
@class StorageKitInfoWindowController;
@class StorageKitStore;
@class StorageKitSavePanel;

@interface StorageKitDocument : NSPersistentDocument <NSWindowDelegate>

@property (nonatomic,strong) NSString * password;
@property (nonatomic,strong) StorageKitInfoWindowController * infoWindowController;
@property (nonatomic) NSInteger itemsToLoad;
@property (nonatomic) NSInteger maxItemsToLoad;
@property (nonatomic,strong) NSString * documentIdentifier;

@property (nonatomic) BOOL merging;
@property (nonatomic) BOOL busy;
@property (nonatomic) BOOL ready;
@property (nonatomic) BOOL checkReadyState;
@property (nonatomic) BOOL closed;


@property (nonatomic,strong) StorageKitBusyWindowController * busyWindowController;

-(IBAction)showInfoSheet:(id)sender;
-(IBAction)resetCache;

-(StorageKitStore *)store;
+(StorageKitSavePanel *)savePanel;
+(BOOL)isCorrectFormat:(NSString *)path;
-(NSArray *)infoArray;
-(BOOL)preflightData:(NSManagedObjectContext *)context;


-(void)documentDidBecomeReady;
-(void)documentDidResignReady;

@end



@interface StorageKitUndoManager : NSUndoManager

@property (nonatomic,strong) NSMutableArray * myUndoStack;
@property (nonatomic,strong) NSMutableArray * myRedoStack;


@end


